/************************************************
* va2.c - the miniprintf callout example		*
*												*
* 900425 MCMason - written for MSC 5.1			*
************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>

/************************************************
* miniprintf - a 'skeletal' type of printf.  It	*
* is used as a demonstration of how you might	*
* go about writing a printf-like function.		*
*												*
* INP:	s - format string.  Any 'i' encountered	*
*			triggers the printing of an int,	*
*			while an 'l' triggers the printing	*
*			of a long.							*
*		... The other parameters ... they should*
*			match in type with the 'i's and 'l's*
************************************************/
void miniprintf(char *s, ...)
	{
	va_list t;
	char buffer[16];

	for (va_start(t,s); *s; ++s)
		if (*s=='i')
			{
			itoa(va_arg(t,int), buffer, 10);
			fputs(buffer,stdout);
			}
		else if (*s=='l')
			{
			ltoa(va_arg(t,long), buffer, 10);
			fputs(buffer,stdout);
			}
		else
			fputc(*s,stdout);
	va_end(t);
	}

void main(void)
	{
	miniprintf("silly test",10,76L,93344356);
	}
